<?php

namespace App\Services\Customer;

use App\Entities\Customer\ClientEntity;
use App\Models\Customer\ClientModel;

class ClientService extends CustomerService
{
    public function __construct(mixed $request = null)
    {
        parent::__construct($request);
        $this->addClassName('Client');
    }
    public function getModelClass(): ClientModel
    {
        return new ClientModel();
    }
    public function getEntityClass(): ClientEntity
    {
        return new ClientEntity();
    }
    public function getFormFields(): array
    {
        return ['name', 'email', 'phone', 'role'];
    }
    public function getFilterFields(): array
    {
        return ['role', 'status'];
    }
    public function getBatchJobFields(): array
    {
        return ['status'];
    }
    public function getIndexFields(): array
    {
        return ['name', 'email', 'phone', 'role', 'account_balance', 'coupon_balance', 'point_balance', 'status'];
    }
    //기본 기능부분

    //압금(쿠폰:추가)처리
    public function deposit(ClientEntity $entity, string $field, int $amount): ClientEntity
    {
        switch ($field) {
            case 'account_balance':
                if ($amount < 0) {
                    throw new \Exception("입금액이 0보다 작습니다.");
                }
                $amount += $entity->getAccountBalance();
                break;
            case 'coupon_balance':
                if ($amount < 0) {
                    throw new \Exception("쿠폰 추가갯수가 0보다 작습니다.");
                }
                $amount += $entity->getCouponBalance();
                break;
            case 'point_balance':
                if ($amount < 0) {
                    throw new \Exception("포인트 입금액 0보다 작습니다.");
                }
                $amount += $entity->getPointBalance();
                break;
            default:
                throw new \Exception("{$field}는 알수없는 Field가 정의되었습니다.");
        }
        $formDatas = [$field => $amount];
        // dd($formDatas);
        return $this->getClientService()->modify($entity, $formDatas);
    }
    //출금(쿠폰:사용)처리
    public function withdrawal(ClientEntity $entity, string $field, int $amount): ClientEntity
    {
        switch ($field) {
            case 'account_balance':
                if ($entity->getAccountBalance() < $amount) {
                    throw new \Exception("예치금[{$entity->getAccountBalance()}]이  출금액:{$amount}보다 부족합니다.");
                }
                $amount = $entity->getAccountBalance() - $amount;
                break;
            case 'coupon_balance':
                if ($entity->getCouponBalance() < $amount) {
                    throw new \Exception("쿠폰[{$entity->getCouponBalance()}]이  사용수:{$amount}보다 부족합니다.");
                }
                $amount = $entity->getCouponBalance() - $amount;
                break;
            case 'point_balance':
                if ($entity->getPointBalance() < $amount) {
                    throw new \Exception("포인트금액[{$entity->getPointBalance()}]이  출금액:{$amount}보다 부족합니다.");
                }
                $amount = $entity->getPointBalance() - $amount;
                break;
            default:
                throw new \Exception("{$field}는 알수없는 Field가 정의되었습니다.");
                // break;
        }
        $formDatas = [$field => $amount];
        return $this->getClientService()->modify($entity, $formDatas);
    }

    public function create(array $formDatas, mixed $entity = new ClientEntity()): ClientEntity
    {
        $formDatas['role'] = implode(DEFAULTS["DELIMITER_ROLE"], $formDatas['role']);
        return parent::create($formDatas, $entity ?? new ClientEntity());
    }
    public function modify(mixed $entity, array $formDatas): ClientEntity
    {
        // die(var_export($formDatas, true));
        //Role을 지정이 있을경우에만 , toggle이나 batcjhjob에서는 없을수도 있으므로
        if (isset($formDatas['role'])) {
            $formDatas['role'] = implode(DEFAULTS["DELIMITER_ROLE"], $formDatas['role']);
        }
        // die(var_export($formDatas, true));
        return parent::modify($entity, $formDatas);
    }
}
